# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from ... import _utilities

__all__ = [
    'GetRepositoryResult',
    'AwaitableGetRepositoryResult',
    'get_repository',
    'get_repository_output',
]

@pulumi.output_type
class GetRepositoryResult:
    """
    A collection of values returned by getRepository.
    """
    def __init__(__self__, description=None, file_path=None, handle=None, id=None, index=None, name=None, node=None, status=None):
        if description and not isinstance(description, str):
            raise TypeError("Expected argument 'description' to be a str")
        pulumi.set(__self__, "description", description)
        if file_path and not isinstance(file_path, str):
            raise TypeError("Expected argument 'file_path' to be a str")
        pulumi.set(__self__, "file_path", file_path)
        if handle and not isinstance(handle, str):
            raise TypeError("Expected argument 'handle' to be a str")
        pulumi.set(__self__, "handle", handle)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if index and not isinstance(index, int):
            raise TypeError("Expected argument 'index' to be a int")
        pulumi.set(__self__, "index", index)
        if name and not isinstance(name, str):
            raise TypeError("Expected argument 'name' to be a str")
        pulumi.set(__self__, "name", name)
        if node and not isinstance(node, str):
            raise TypeError("Expected argument 'node' to be a str")
        pulumi.set(__self__, "node", node)
        if status and not isinstance(status, int):
            raise TypeError("Expected argument 'status' to be a int")
        pulumi.set(__self__, "status", status)

    @property
    @pulumi.getter
    def description(self) -> str:
        """
        The description of the APT standard repository.
        """
        return pulumi.get(self, "description")

    @property
    @pulumi.getter(name="filePath")
    def file_path(self) -> str:
        """
        The absolute path of the source list file that contains this standard repository.
        """
        return pulumi.get(self, "file_path")

    @property
    @pulumi.getter
    def handle(self) -> str:
        """
        The handle of the APT standard repository.
        """
        return pulumi.get(self, "handle")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The unique identifier of this APT standard repository data source.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def index(self) -> int:
        """
        The index within the defining source list file.
        """
        return pulumi.get(self, "index")

    @property
    @pulumi.getter
    def name(self) -> str:
        """
        The name of the APT standard repository.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def node(self) -> str:
        """
        The name of the target Proxmox VE node.
        """
        return pulumi.get(self, "node")

    @property
    @pulumi.getter
    def status(self) -> int:
        """
        Indicates the activation status.
        """
        return pulumi.get(self, "status")


class AwaitableGetRepositoryResult(GetRepositoryResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetRepositoryResult(
            description=self.description,
            file_path=self.file_path,
            handle=self.handle,
            id=self.id,
            index=self.index,
            name=self.name,
            node=self.node,
            status=self.status)


def get_repository(handle: Optional[str] = None,
                   node: Optional[str] = None,
                   opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetRepositoryResult:
    """
    Retrieves an APT standard repository from a Proxmox VE cluster.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_proxmoxve as proxmoxve

    example = proxmoxve.Apt.standard.get_repository(handle="no-subscription",
        node="pve")
    pulumi.export("proxmoxVirtualEnvironmentAptStandardRepository", example)
    ```


    :param str handle: The handle of the APT standard repository.
    :param str node: The name of the target Proxmox VE node.
    """
    __args__ = dict()
    __args__['handle'] = handle
    __args__['node'] = node
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('proxmoxve:Apt/standard/getRepository:getRepository', __args__, opts=opts, typ=GetRepositoryResult).value

    return AwaitableGetRepositoryResult(
        description=pulumi.get(__ret__, 'description'),
        file_path=pulumi.get(__ret__, 'file_path'),
        handle=pulumi.get(__ret__, 'handle'),
        id=pulumi.get(__ret__, 'id'),
        index=pulumi.get(__ret__, 'index'),
        name=pulumi.get(__ret__, 'name'),
        node=pulumi.get(__ret__, 'node'),
        status=pulumi.get(__ret__, 'status'))


@_utilities.lift_output_func(get_repository)
def get_repository_output(handle: Optional[pulumi.Input[str]] = None,
                          node: Optional[pulumi.Input[str]] = None,
                          opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetRepositoryResult]:
    """
    Retrieves an APT standard repository from a Proxmox VE cluster.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_proxmoxve as proxmoxve

    example = proxmoxve.Apt.standard.get_repository(handle="no-subscription",
        node="pve")
    pulumi.export("proxmoxVirtualEnvironmentAptStandardRepository", example)
    ```


    :param str handle: The handle of the APT standard repository.
    :param str node: The name of the target Proxmox VE node.
    """
    ...
